part of itwo_util;

class DateTimeUtil {
  static final String full = 'yyyy-MM-dd HH:mm:ss';
  static final String y_mo_d_h_m = 'yyyy-MM-dd HH:mm';
  static final String y_mo_d = 'yyyy-MM-dd';
  static final String y_mo = 'yyyy-MM';
  static final String mo_d = 'MM-dd';
  static final String mo_d_h_m = 'MM-dd HH:mm';
  static final String h_m_s = 'HH:mm:ss';
  static final String h_m = 'HH:mm';

  static final String zh_full = 'yyyy年MM月dd日 HH时mm分ss秒';
  static final String zh_y_mo_d_h_m = 'yyyy年MM月dd日 HH时mm分';
  static final String zh_y_mo_d = 'yyyy年MM月dd日';
  static final String zh_y_mo = 'yyyy年MM月';
  static final String zh_mo_d = 'MM月dd日';
  static final String zh_mo_d_h_m = 'MM月dd日 HH时mm分';
  static final String zh_h_m_s = 'HH时mm分ss秒';
  static final String zh_h_m = 'HH时mm分';

  /// dateTime 转 字符串  DateTime() => yyyy-MM-dd HH:mm:ss
  static String formatDateTime({DateTime? dateTime, String? pattern}) {
    if (dateTime == null) dateTime = DateTime.now();
    if (pattern == null) pattern = full;
    return DateFormat(pattern).format(dateTime);
  }

  /// 毫秒级时间戳 转 字符串  1317650580814 => yyyy-MM-dd HH:mm:ss
  static String formatTimestamp({int? timestamp, String? pattern}) {
    if (pattern == null) pattern = full;
    var dateTime = timestamp == null ? DateTime.now() : DateTime.fromMillisecondsSinceEpoch(timestamp);
    return formatDateTime(dateTime: dateTime, pattern: pattern);
  }

  static DateTime? parse(String formattedString) {
    return DateTime.tryParse(formattedString);
  }

  ///指定日期所在月的第一天
  static DateTime firstDayOfMonth({DateTime? date}) {
    if (date == null) date = DateTime.now();
    print('${date.toString()}');
    return DateTime(date.year, date.month);
  }

  ///指定日期所在月的最后
  static DateTime lastDayOfMonth({DateTime? date}) {
    if (date == null) date = DateTime.now();
    var year = date.year;
    var month = date.month + 1;
    if (month > 12) {
      year++;
      month = 1;
    }
    DateTime lastMonth = DateTime(year, month);
    var lastDay = firstDayOfMonth(date: lastMonth).add(Duration(days: -1));
    return lastDay;
  }

  /// 指定日期所在周的周一
  static DateTime firstDayOfWeek({DateTime? date}) {
    if (date == null) date = DateTime.now();
    if (date.weekday == 1) return date;
    return date.add(Duration(days: -(date.weekday - 1)));
  }

  static DateTime lastDayOfWeek({DateTime? date}) {
    if (date == null) date = DateTime.now();
    if (date.weekday == 7) return date;
    return date.add(Duration(days: 7 - date.weekday));
  }
}
