part of itwo_util;

class ScreenUtil {
  static MediaQueryData _mediaQueryData = MediaQueryData.fromWindow(ui.window);

  ScreenUtil._();

  static MediaQueryData get mediaQuery => _mediaQueryData;

  static double get screenWidth => _mediaQueryData.size.width;

  static double get screenHeight => _mediaQueryData.size.height;

  static double get statusBarHeight => _mediaQueryData.padding.top;

  static double get devicePixelRatio => _mediaQueryData.devicePixelRatio;

  /// 设置 MaterialApp 中 builder 属性，使字体大小不跟随系统设置
  static TransitionBuilder get forceTextScaleFactor => (c, w) => MediaQuery(data: _mediaQueryData.copyWith(textScaleFactor: 1), child: w ?? Container());
}
