part of itwo_util;

///  保留两位小数 double.toStringAsFixed

class StringUtil {
  static bool isEmpty(String? str) => str == null || str.length == 0;

  /// 每隔 x位 加 pattern
  static String formatDigitPattern(String text, {int digit = 4, String pattern = ' '}) {
    text = text.replaceAllMapped(RegExp('(.{$digit})'), (Match match) {
      return '${match.group(0)}$pattern';
    });
    if (text.endsWith(pattern)) {
      text = text.substring(0, text.length - 1);
    }
    return text;
  }

  /// 每隔 x位 加 pattern, 从末尾开始
  static String formatDigitPatternEnd(String text, {int digit = 4, String pattern = ' '}) {
    String temp = text.reverse;
    temp = formatDigitPattern(temp, digit: digit, pattern: pattern);
    temp = temp.reverse;
    return temp;
  }

  //隐藏电话中间4位
  static String hideMobile(String str) {
    return str.replaceRange(4, 7, "****");
  }
}

extension StringExtNull on String? {
  bool get isNullOrEmpty => this == null || this?.length == 0;
}

extension StringExt on String {
  ///翻转字符
  String get reverse {
    if (this.isEmpty) return '';
    StringBuffer sb = StringBuffer();
    for (int i = length - 1; i >= 0; i--) {
      sb.writeCharCode(codeUnitAt(i));
    }
    return sb.toString();
  }

  int? toIntOrNull() => int.tryParse(this);

  double? toDoubleOrNull() => double.tryParse(this);

  Color toColor() {
    try {
      var c = this.replaceAll("#", "");
      if (c.length == 6) c = "FF" + c;
      return Color(int.parse(c, radix: 16));
    } catch (e) {
      throw 'Color parse error $e';
    }
  }
}
